#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk

class ComboBoxExample:
    def __init__(self):
        window = gtk.Window()
        window.connect('destroy', lambda w: gtk.main_quit())
        self.liststore = gtk.ListStore(str,int)
        self.liststore.append(['apple',0])
        self.liststore.append(['cherry',2])
        self.liststore.append(['blueberry',4])
        self.liststore.append(['switch-to-color',4])
        self.liststore2 = gtk.ListStore(str,int)
        self.liststore2.append(['yellow',0])
        self.liststore2.append(['red',2])
        self.liststore2.append(['blue',4])
        self.liststore2.append(['switch-to-pie',4])
        self.combobox = gtk.ComboBoxEntry(self.liststore,0)
        cell = gtk.CellRendererText()
        self.combobox.pack_start(cell,True)
        #combobox.add_attribute(cell,'text',0)
        #combobox = gtk.combo_box_new_text()
        self.combobox.set_wrap_width(2)
        window.add(self.combobox)
        #combobox.append_text('Select a pie:')
        #combobox.append_text('Apple')
        #combobox.append_text('Cherry')
       # combobox.append_text('Blueberry')
       # combobox.append_text('Grape')
       # combobox.append_text('Peach')
        #combobox.append_text('Raisin')
        self.combobox.connect('changed', self.changed_cb)
        self.combobox.child.connect('activate', self.add_cb)
        self.combobox.set_active(0)
        window.show_all()
        return

    def changed_cb(self, combobox):
        model = self.combobox.get_model()
        index = self.combobox.get_active()           
        print 'index -> ', index
        if index == -1:return
        text = model[index][0]
        print 'I like',text , 'pie',model[index][1]
        if text == 'switch-to-color':
            self.combobox.set_model(self.liststore2)
            self.combobox.set_active(0)
        elif text == 'switch-to-pie':
            self.combobox.set_model(self.liststore)
            self.combobox.set_active(0)
        return

    def add_cb(self, combobox):
        model = self.combobox.get_model()
        index = self.combobox.get_active()
        if index == -1:
            newtext = self.combobox.get_active_text()  
            model.append([newtext,len(model)+1])
def main():
    gtk.main()
    return

if __name__ == "__main__":
    bcb = ComboBoxExample()
    main()

